/***************************************************************************
 *   Copyright (C) 2009 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QKM_H
#define QKM_H

#include <QWidget>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QPushButton>
#include <QDBusInterface>
#include <QResizeEvent>

#include "qspeedgroup.h"
#include "qcountergroup.h"
/**
	@author Rico Rommel <rico@bierrommel.de>
*/
class qkm : public QWidget
{
Q_OBJECT
public:
    qkm(QWidget *parent = 0);

    ~qkm();
    double deg2rad( double deg );

protected:
    QVBoxLayout * MainLayout;
    QHBoxLayout * SpeedLayout;
    QSpeedGroup * currentSpeedLabel;
    QSpeedGroup * maxSpeedLabel;
    QCounterGroup * counter[3];
    QPushButton * CloseButton;
    QPushButton * ResetMaxSpeedButton;
    double lastlat, lastlon, lastalt;
    int lastTime, currentTime;
    double R;
    QDBusInterface * DevInterface;
    QDBusInterface * PosInterface;
protected slots:
    void onCloseButtonClicked();
    void onPositionChanged(int f, int ts, double lat, double lon, double alt);
    void resetMaxSpeed();
};

#endif
